# Decorator to add some special features to a User
# TODO: This is a strong relationship to DeviseAuthentication and will to stop work if we use anything different!! (se)
DeviseAuthentication::User.class_eval do
    if Rails.env != "test"
        # Add jwt support to the user model
        include Devise::JWT::RevocationStrategies::JTIMatcher
        devise :jwt_authenticatable, jwt_revocation_strategy: self
        field :jti, :type => String, :unique => true, :index => true
    end


    # Add current organisation
    def jwt_payload
        init_current_membership
        {
            'membership_id' => @current_membership.id,
            'jti' => jti
        }
    end

    # Required by devise-jwt in order to find the correct user
    def self.primary_key
        "id"
    end

    # Called by devise-swt in order to find the user..
    def self.find_by(params)
        self.find(params["id"])
    end

    def self.revoke_jwt(_payload, user)
        return if user.nil?
        user.update(:jti => generate_jti)
    end
end
